<?php
/* $Id: dbfm_admin.inc,v 1.1.2.18 2008/06/02 16:12:39 geoffeagles Exp $ */


/**
 * Implementation of hook_settings().
 */
function dbfm_admin_settings() {

  $form['dbfm_main'] = array (
          '#type' => 'fieldset',
          '#title' => 'Basic settings',
          '#collapsible' => TRUE,
          '#collapsed' => FALSE, 
          );

  $form['dbfm_main']['dbfm_root_dir'] =
    array('#type' => 'textfield',
          '#title' => t('Root directory'),
          '#default_value' => variable_get('dbfm_root_dir', 'dbfm'),
          '#maxlength' => '100',
          '#size' => '70',
          '#description' => t('Root directory used to present the filebrowser interface.  Users will not be able
                               <br />to go up from this folder. NO SLASH')
          );

  $modulepath = drupal_get_path('module', 'dbfm');
  $form['dbfm_main']['dbfm_icon_dir'] =
    array('#type' => 'textfield',
          '#title' => t('Icon directory'),
          '#default_value' => variable_get('dbfm_icon_dir', $modulepath. '/image/icon'),
          '#maxlength' => '100',
          '#size' => '70',
          '#description' => t('Name of directory where file type icons are stored (relative to base url).')
         );

  $form['dbfm_main']['dbfm_node_grp'] =
    array('#type' => 'textfield',
          '#title' => t('Node group type'),
          '#default_value' => variable_get('dbfm_node_grp', 'groupnode'),
          '#maxlength' => '20',
          '#size' => '20',
          '#description' => t('If you are using group access permissions you will need to complete the node type given to group nodes')
         );

  $form['dbfm_main']['dbfm_dbreset'] =
    array('#type' => 'checkbox',
          '#title' => t('Reset filecounts'),
          '#default_value' => false,
          '#description' => t('If you suspect that the database filecounts may be wrong then check this (doesnt hurt anyway though it gobbles up db resource)')
          );


  $form['dbfm_main']['dbfm_nozip'] =
    array('#type' => 'textarea',
          '#title' => t('Don\'t compress'),
          '#default_value' => variable_get('dbfm_nozip', 'arc arj as b64 bin btoa bz cab cpt gz hqx iso lha lzh mim mme pak pf rar sea sit sitx tar tbz tbz2 tgz uu uue z zip zoo'),
          '#description' => t('Files that are already compressed and should be stored as-is in the database (use space delimited with no leading dot)') );

   //fill in which pages need to use dbfm
   $form['dbfm_main']['dbfm_pages'] = 
     array('#type' => 'textarea',
           '#title' => t('Activate dbfm on specific page types'),
           '#default_value' => variable_get('dbfm_pages', "node edit,\nnode add"),
           '#description' => t('Enter one page type per line with a comma at the end of the line (for neatness). Example types might be "node" for all node pages or "node add" which limits the user to having greybox only when adding nodes. You shouldn\'t include the slashes. The reason you would want to disallow dbfm is because it saves loading the java code into the page header - pages should load faster! and it reduces possible interactions with other javascript'));

  //If we're a slave let them set the variables associated with replication
  if (variable_get('replication_server_mode','0') == 2) {
  $form['dbfm_main']['replication'] =
    array('#type' => 'fieldset',
          '#title' => 'Replication settings',
          '#collapsible' => TRUE,
          '#collapsed' => TRUE, 
          );

    $form['dbfm_main']['replication']['dbfm_refreshdelay'] =
      array('#type' => 'textfield',
          '#title' => t('Re-query delay'),
          '#default_value' => variable_get('dbfm_refreshdelay', 5),
          '#maxlength' => '3',
          '#size' => '3',
          '#description' => t('The DBFM client will automatically re-query the server every n seconds to find changes to the directory structure')
        );
    $form['dbfm_main']['replication']['dbfm_lastreplicate'] =
      array('#type' => 'textfield',
            '#title' => t('Last replicate date'),
            '#default_value' => variable_get('dbfm_lastreplicate', date("Y-m-d H:i:s")),
            '#maxlength' => '20',
            '#size' => '20',
            '#description' => t('Replication will only consider files modified since the date held in this variable. Format is YYYY-MM-DD HH:MM:SS')
          );
    $form['dbfm_main']['replication']['dbfm_cron_reptime'] =
      array('#type' => 'textfield',
            '#title' => t('Maximum replication time'),
            '#default_value' => variable_get('dbfm_cron_reptime', 150),
            '#maxlength' => '4',
            '#size' => '4',
            '#description' => t('The dbfm replication process will be terminated after this number of seconds')
          );

    $form['dbfm_main']['replication']['dbfm_cron_repenabled'] =
      array('#type' => 'checkbox',
          '#title' => t('Replication Cron Enabled'),
          '#default_value' => variable_get('dbfm_cron_repenabled', false),
          '#description' => t('Switches on replication of dbfm files using cron'),
          );
          
//    $form['dbfm_main']['replication']['dbfm_lastreplicate'] =
//      array('#type' => 'textfield',
//            '#title' => t('Start replicating records from this date'),
//            '#default_value' => variable_get('dbfm_lastreplicate', date("Y-m-d H:i:s")),
//            '#maxlength' => '20',
//            '#size' => '14',
//            '#description' => t('Only change this value if the dbfm_data table is not fully populated')
//          );

    $form['dbfm_main']['replication']['dbfm_smallfile'] =
      array('#type' => 'textfield',
            '#title' => t('Small file max. filesize (Bytes)'),
            '#default_value' => variable_get('dbfm_smallfile', 1000000),
            '#maxlength' => '10',
            '#size' => '10',
            '#description' => t("Small files (below the size defined here) which haven't yet been replicated can be loaded directly from the master"),
          );

  }



  // this is new to me, returns an array of valid roles (avoids anonymous users)
  $roles = user_roles(1,0);

  // Flush extensions regex cache for upload and db enum 
  // ZZZZZZZZZZ dunno what this is about??
  dbfm_get_extensions_regex(FLUSH);

  foreach ($roles as $rid => $role) {
    $form["settings_role_".$rid] =
      array('#type' => 'fieldset',
            '#title' => t('Settings for @role', array('@role' => $role)),
            '#collapsible' => TRUE,
            '#collapsed' => TRUE
            );

    $form["settings_role_".$rid]["dbfm_extensions_".$rid] =
      array('#type' => 'textfield',
            '#title' => t('Permitted file extensions'),
            '#default_value' => variable_get("dbfm_extensions_".$rid, "ai doc dot eps exe gif gxd gz html htm ind jpg jpeg pdf png ppt pps psd qxd swf tif tiff txt xls zip"),
            '#maxlength' => 255,
            '#description' => t('Extensions that users in this role can upload. (use space delimited with no leading dot).')
            );

    $form["settings_role_".$rid]["dbfm_uploadsize_".$rid] =
      array('#type' => 'textfield',
            '#title' => t('Maximum file size per upload'),
            '#default_value' => variable_get("dbfm_uploadsize_".$rid, 1),
            '#size' => 5,
            '#maxlength' => 5,
            '#description' => t('The maximum size of a file a user can upload (in megabytes).')
            );

    $form["settings_role_".$rid]["dbfm_usersize_".$rid] =
      array('#type' => 'textfield',
            '#title' => t('Total file size per user'),
            '#default_value' => variable_get("dbfm_usersize_".$rid, 10),
            '#size' => 5,
            '#maxlength' => 5,
            '#description' => t('The maximum size of all files a user can have on the site (in megabytes).')
            );
  }
  return system_settings_form($form);
}


/**
 * Submit code for the admin form
 *
 * @param int $form_id
 * @param array $form_values
 *
 */

function dbfm_admin_settings_submit($form_id, $form_values) {
  global $user;
  $err = "";  //declare a string used to return error messages

  //we need a little extra code on the admin form submit to make sure that the root directory is saved to the database
  //test whether they've set BLOB to true and make an entry in the database to hold the root directory name
  //if this is ever changed all the files will automatically move with it (because they're parented by it) BUT
  //their paths will need to be edited - if the system is large this is a very bad idea, get the name right first!

  //we should also be creating the root directory, if it doesn't already exist, for non-blob systems
  // we can easily spot whether they're changing an existing entry!!!

  $setmime = 'directory';
  
  //we need to test whether there's a root entry in the database - don't need to do it like this - the root entry will always have
  //an fid of 1
  //the third parameter suppresses errors
  $rootrec = dbfm_selected_file_record(1, '', $err);
  if ($rootrec == FALSE) {
    // there's no root entry in the database, we'll have to add one, do some checking on the name to
    //ensure it's valid
    if (checkname($form_values['dbfm_root_dir'])) {
      // insert the new entry
      $dirpath = '/' . trim($form_values['dbfm_root_dir']);
      $currentdate = date("Y-m-d H:i:s");

      $result = db_query("INSERT INTO {dbfm_file} (fid, uid, fpath, fname, fsize, fmime, fcreatedate, flastmod, fparent, fwaccess) VALUES (%d, %d, '%s', '%s', %d, '%s', '%s', '%s', %d, %d)",1, $user->uid, $dirpath, trim($form_values['dbfm_root_dir']), 0, $setmime, $currentdate, $currentdate, 0, READ_WRITE);
      // FOOBAR1
      $result = db_query("INSERT INTO {dbfm_perm} (fid, rgaccess, rgid) VALUES (%d, %d, %d)", 1, 0, 0);
      if ($result === FALSE) {
        drupal_set_message("ERROR: Failed to insert the directory " . $dest . " into the database");
        return FALSE;
      }
    }
    else {
      // the checkname function will have returned an appropriate error message
      return FALSE;
    }
  }
  else {
    //we HAVE already got a root directory entry in the database

    //found a root entry, are they trying to change it? if so do an update
    if ($form_values['dbfm_root_dir'] != $rootrec->fname) {
      if (checkname($form_values['dbfm_root_dir']) == FALSE) {
        //should have reported its error
        return FALSE;
      }

      $dirpath = '/' . trim($form_values['dbfm_root_dir']);
      $currentdate = date("Y-m-d H:i:s");

      $result = db_query("UPDATE {dbfm_file} SET fpath = '%s', fname = '%s', flastmod = '%s' WHERE fid = %d;", $dirpath, trim($form_values['dbfm_root_dir']), $currentdate, $rootrec->fid);

      if ($result === FALSE) {
        drupal_set_message("ERROR: Failed update the root directory to " . $form_values['dbfm_root_dir']);
        return FALSE;
      }

      if ($rootrec->fsize > 0) {
        //now we need to recursively rename everything underneath
        $ret = TRUE;
        $err_arr = "";

        // we need to update the local rootrec before calling a recursive routine to modify all the child records
        $rootrec->fpath = $dirpath;

        $ret = dbfm_recur_dbrename($rootrec, $ret, $err_arr);
        if ($ret == FALSE) {
          drupal_set_message($err_arr);
          return $ret;
        }
      }
    }
  }

  //calls a function to rebuild the directory size values in the database - could take a while...
  if ($form_values['dbfm_dbreset']) {
    dbfm_resetdb();
  }

  //how do we get it to execute the default code as well? - here's how!
  system_settings_form_submit($form_id, $form_values);
}
