// $Id: editor_plugin.js,v 1.1.2.5 2008/05/30 14:29:03 geoffeagles Exp $
/* Import plugin specific language pack */


tinyMCE.importPluginLanguagePack('drupaldbfm', 'en');

var TinyMCE_drupaldbfmPlugin = {
  getInfo : function() {
    return {
      longname : 'drupaldbfm',
      author : 'Geoff Eagles and Michael Heath',
      authorurl : 'http://www.eservglobal.com',
      infourl : 'http://drupal.org/project/dbfm',
      version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
    };
  },

  initInstance : function(inst) {
    if (!tinyMCE.settings['drupaldbfm_skip_plugin_css'])
      tinyMCE.importCSS(inst.getDoc(), tinyMCE.baseURL + "/plugins/drupaldbfm/drupaldbfm.css");
  },

  getControlHTML : function(cn) {
    switch (cn) {
      case "drupaldbfm":
        return tinyMCE.getButtonHTML(cn, 'lang_drupaldbfm_desc', '{$pluginurl}/images/drupaldbfm.png', 'mcedrupaldbfm');
    }

    return "";
  },

  execCommand : function(editor_id, element, command, user_interface, value) {
    // Handle commands
    switch (command) {
      case "mcedrupaldbfm":
        var myurl = '';
        var inst = tinyMCE.getInstanceById(editor_id);
        var focusElm = inst.getFocusElement();

        // get base url NOTE THIS WILL NEED EDITING IF YOUR MODULE DOESN'T LIVE UNDER SITES OR MODULES
        var base_url = tinyMCE.baseURL;
        base_url = base_url.substring(0, base_url.indexOf('sites'));
//        base_url = base_url.substring(0, base_url.indexOf('modules'));

        myurl = base_url + 'dbfm_attachit';
 
        //a rewrite here to bring up a greybox - not sure whether I need more in the way of a path to attachit
        var t = 'DB File Manager Link / Embed';
        GB_show(t, myurl, 516, 680);
        //ok, this works ... now we just need to write back into the editor

      return true;
     }

     // Pass to next handler in chain
     return false;
  },
  
  cleanup : function(type, content) {

    // Pass through to next handler in chain
    return content;
  }
};

tinyMCE.addPlugin("drupaldbfm", TinyMCE_drupaldbfmPlugin);

